* sh.c (sh_can_use_simple_return_p): Return false for SHmedia
[official-gcc.git] / libgo / mksysinfo.sh
blob315d60cc39d881c8f4aafdfe448b4dbd81647124
1 #!/bin/sh
3 # Copyright 2009 The Go Authors. All rights reserved.
4 # Use of this source code is governed by a BSD-style
5 # license that can be found in the LICENSE file.
7 # Create sysinfo.go.
9 # This shell script creates the sysinfo.go file which holds types and
10 # constants extracted from the system header files. This relies on a
11 # hook in gcc: the -fdump-go-spec option will generate debugging
12 # information in Go syntax.
14 # We currently #include all the files at once, which works, but leads
15 # to exposing some names which ideally should not be exposed, as they
16 # match grep patterns. E.g., WCHAR_MIN gets exposed because it starts
17 # with W, like the wait flags.
19 CC=${CC:-gcc}
20 OUT=tmp-sysinfo.go
22 set -e
24 rm -f sysinfo.c
25 cat > sysinfo.c <<EOF
26 #include "config.h"
28 #include <sys/types.h>
29 #include <dirent.h>
30 #include <errno.h>
31 #include <fcntl.h>
32 #include <netinet/in.h>
33 /* <netinet/tcp.h> needs u_char/u_short, but <sys/bsd_types> is only
34 included by <netinet/in.h> if _SGIAPI (i.e. _SGI_SOURCE
35 && !_XOPEN_SOURCE.
36 <sys/termios.h> only defines TIOCNOTTY if !_XOPEN_SOURCE, while
37 <sys/ttold.h> does so unconditionally. */
38 #ifdef __sgi__
39 #include <sys/bsd_types.h>
40 #include <sys/ttold.h>
41 #endif
42 #include <netinet/tcp.h>
43 #if defined(HAVE_NETINET_IN_SYSTM_H)
44 #include <netinet/in_systm.h>
45 #endif
46 #if defined(HAVE_NETINET_IP_H)
47 #include <netinet/ip.h>
48 #endif
49 #if defined(HAVE_NETINET_IP_MROUTE_H)
50 #include <netinet/ip_mroute.h>
51 #endif
52 #if defined(HAVE_NETINET_IF_ETHER_H)
53 #include <netinet/if_ether.h>
54 #endif
55 #include <signal.h>
56 #include <sys/ioctl.h>
57 #include <termios.h>
58 #if defined(HAVE_SYSCALL_H)
59 #include <syscall.h>
60 #endif
61 #if defined(HAVE_SYS_SYSCALL_H)
62 #include <sys/syscall.h>
63 #endif
64 #if defined(HAVE_SYS_EPOLL_H)
65 #include <sys/epoll.h>
66 #endif
67 #if defined(HAVE_SYS_FILE_H)
68 #include <sys/file.h>
69 #endif
70 #if defined(HAVE_SYS_MMAN_H)
71 #include <sys/mman.h>
72 #endif
73 #if defined(HAVE_SYS_PRCTL_H)
74 #include <sys/prctl.h>
75 #endif
76 #if defined(HAVE_SYS_PTRACE_H)
77 #include <sys/ptrace.h>
78 #endif
79 #include <sys/resource.h>
80 #include <sys/uio.h>
81 #include <sys/socket.h>
82 #include <sys/stat.h>
83 #include <sys/time.h>
84 #include <sys/times.h>
85 #include <sys/wait.h>
86 #include <sys/un.h>
87 #if defined(HAVE_SYS_USER_H)
88 #include <sys/user.h>
89 #endif
90 #if defined(HAVE_SYS_UTSNAME_H)
91 #include <sys/utsname.h>
92 #endif
93 #if defined(HAVE_SYS_SELECT_H)
94 #include <sys/select.h>
95 #endif
96 #include <time.h>
97 #include <unistd.h>
98 #include <netdb.h>
99 #include <pwd.h>
100 #if defined(HAVE_LINUX_FILTER_H)
101 #include <linux/filter.h>
102 #endif
103 #if defined(HAVE_LINUX_IF_ADDR_H)
104 #include <linux/if_addr.h>
105 #endif
106 #if defined(HAVE_LINUX_IF_ETHER_H)
107 #include <linux/if_ether.h>
108 #endif
109 #if defined(HAVE_LINUX_IF_TUN_H)
110 #include <linux/if_tun.h>
111 #endif
112 #if defined(HAVE_LINUX_NETLINK_H)
113 #include <linux/netlink.h>
114 #endif
115 #if defined(HAVE_LINUX_RTNETLINK_H)
116 #include <linux/rtnetlink.h>
117 #endif
118 #if defined(HAVE_NET_IF_H)
119 #include <net/if.h>
120 #endif
121 #if defined(HAVE_NET_IF_ARP_H)
122 #include <net/if_arp.h>
123 #endif
124 #if defined(HAVE_NET_ROUTE_H)
125 #include <net/route.h>
126 #endif
127 #if defined (HAVE_NETPACKET_PACKET_H)
128 #include <netpacket/packet.h>
129 #endif
130 #if defined(HAVE_SYS_MOUNT_H)
131 #include <sys/mount.h>
132 #endif
133 #if defined(HAVE_SYS_VFS_H)
134 #include <sys/vfs.h>
135 #endif
136 #if defined(HAVE_STATFS_H)
137 #include <sys/statfs.h>
138 #endif
139 #if defined(HAVE_SYS_TIMEX_H)
140 #include <sys/timex.h>
141 #endif
142 #if defined(HAVE_SYS_SYSINFO_H)
143 #include <sys/sysinfo.h>
144 #endif
145 #if defined(HAVE_USTAT_H)
146 #include <ustat.h>
147 #endif
148 #if defined(HAVE_UTIME_H)
149 #include <utime.h>
150 #endif
151 #if defined(HAVE_LINUX_ETHER_H)
152 #include <linux/ether.h>
153 #endif
154 #if defined(HAVE_LINUX_FS_H)
155 #include <linux/fs.h>
156 #endif
157 #if defined(HAVE_LINUX_REBOOT_H)
158 #include <linux/reboot.h>
159 #endif
160 #if defined(HAVE_SYS_INOTIFY_H)
161 #include <sys/inotify.h>
162 #endif
164 /* Constants that may only be defined as expressions on some systems,
165 expressions too complex for -fdump-go-spec to handle. These are
166 handled specially below. */
167 enum {
168 #ifdef TIOCGWINSZ
169 TIOCGWINSZ_val = TIOCGWINSZ,
170 #endif
174 ${CC} -fdump-go-spec=gen-sysinfo.go -std=gnu99 -S -o sysinfo.s sysinfo.c
176 echo 'package syscall' > ${OUT}
177 echo 'import "unsafe"' >> ${OUT}
178 echo 'type _ unsafe.Pointer' >> ${OUT}
180 # Get all the consts and types, skipping ones which could not be
181 # represented in Go and ones which we need to rewrite. We also skip
182 # function declarations, as we don't need them here. All the symbols
183 # will all have a leading underscore.
184 grep -v '^// ' gen-sysinfo.go | \
185 grep -v '^func' | \
186 grep -v '^type _timeval ' | \
187 grep -v '^type _timespec_t ' | \
188 grep -v '^type _timespec ' | \
189 grep -v '^type _timestruc_t ' | \
190 grep -v '^type _epoll_' | \
191 grep -v 'in6_addr' | \
192 grep -v 'sockaddr_in6' | \
193 sed -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
194 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
195 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
196 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
197 >> ${OUT}
199 # The errno constants. These get type Errno.
200 echo '#include <errno.h>' | ${CC} -x c - -E -dM | \
201 egrep '#define E[A-Z0-9_]+ ' | \
202 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(_\1)/' >> ${OUT}
204 # The O_xxx flags.
205 egrep '^const _(O|F|FD)_' gen-sysinfo.go | \
206 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
207 if ! grep '^const O_ASYNC' ${OUT} >/dev/null 2>&1; then
208 echo "const O_ASYNC = 0" >> ${OUT}
210 if ! grep '^const O_CLOEXEC' ${OUT} >/dev/null 2>&1; then
211 echo "const O_CLOEXEC = 0" >> ${OUT}
214 # These flags can be lost on i386 GNU/Linux when using
215 # -D_FILE_OFFSET_BITS=64, because we see "#define F_SETLK F_SETLK64"
216 # before we see the definition of F_SETLK64.
217 for flag in F_GETLK F_SETLK F_SETLKW; do
218 if ! grep "^const ${flag} " ${OUT} >/dev/null 2>&1 \
219 && grep "^const ${flag}64 " ${OUT} >/dev/null 2>&1; then
220 echo "const ${flag} = ${flag}64" >> ${OUT}
222 done
224 # The signal numbers.
225 grep '^const _SIG[^_]' gen-sysinfo.go | \
226 grep -v '^const _SIGEV_' | \
227 sed -e 's/^\(const \)_\(SIG[^= ]*\)\(.*\)$/\1\2 = Signal(_\2)/' >> ${OUT}
229 # The syscall numbers. We force the names to upper case.
230 grep '^const _SYS_' gen-sysinfo.go | \
231 sed -e 's/const _\(SYS_[^= ]*\).*$/\1/' | \
232 while read sys; do
233 sup=`echo $sys | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
234 echo "const $sup = _$sys" >> ${OUT}
235 done
237 # The GNU/Linux support wants to use SYS_GETDENTS64 if available.
238 if ! grep '^const SYS_GETDENTS ' ${OUT} >/dev/null 2>&1; then
239 echo "const SYS_GETDENTS = 0" >> ${OUT}
241 if ! grep '^const SYS_GETDENTS64 ' ${OUT} >/dev/null 2>&1; then
242 echo "const SYS_GETDENTS64 = 0" >> ${OUT}
245 # Stat constants.
246 grep '^const _S_' gen-sysinfo.go | \
247 sed -e 's/^\(const \)_\(S_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
249 # Mmap constants.
250 grep '^const _PROT_' gen-sysinfo.go | \
251 sed -e 's/^\(const \)_\(PROT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
252 grep '^const _MAP_' gen-sysinfo.go | \
253 sed -e 's/^\(const \)_\(MAP_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
254 grep '^const _MADV_' gen-sysinfo.go | \
255 sed -e 's/^\(const \)_\(MADV_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
256 grep '^const _MCL_' gen-sysinfo.go | \
257 sed -e 's/^\(const \)_\(MCL_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
259 # Process status constants.
260 grep '^const _W' gen-sysinfo.go |
261 sed -e 's/^\(const \)_\(W[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
262 # WSTOPPED was introduced in glibc 2.3.4.
263 if ! grep '^const _WSTOPPED = ' gen-sysinfo.go >/dev/null 2>&1; then
264 if grep '^const _WUNTRACED = ' gen-sysinfo.go > /dev/null 2>&1; then
265 echo 'const WSTOPPED = _WUNTRACED' >> ${OUT}
266 else
267 echo 'const WSTOPPED = 2' >> ${OUT}
270 if grep '^const ___WALL = ' gen-sysinfo.go >/dev/null 2>&1 \
271 && ! grep '^const _WALL = ' gen-sysinfo.go >/dev/null 2>&1; then
272 echo 'const WALL = ___WALL' >> ${OUT}
275 # Networking constants.
276 egrep '^const _(AF|ARPHRD|ETH|IN|SOCK|SOL|SO|IPPROTO|TCP|IP|IPV6)_' gen-sysinfo.go |
277 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
278 grep '^const _SOMAXCONN' gen-sysinfo.go |
279 sed -e 's/^\(const \)_\(SOMAXCONN[^= ]*\)\(.*\)$/\1\2 = _\2/' \
280 >> ${OUT}
281 grep '^const _SHUT_' gen-sysinfo.go |
282 sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
284 # The net package requires some const definitions.
285 for m in IP_PKTINFO IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_TCLASS SO_REUSEPORT; do
286 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
287 echo "const $m = 0" >> ${OUT}
289 done
291 # pathconf constants.
292 grep '^const __PC' gen-sysinfo.go |
293 sed -e 's/^\(const \)__\(PC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
295 # The PATH_MAX constant.
296 if grep '^const _PATH_MAX ' gen-sysinfo.go >/dev/null 2>&1; then
297 echo 'const PathMax = _PATH_MAX' >> ${OUT}
300 # epoll constants.
301 grep '^const _EPOLL' gen-sysinfo.go |
302 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
303 # Make sure EPOLLRDHUP and EPOLL_CLOEXEC are defined.
304 if ! grep '^const EPOLLRDHUP' ${OUT} >/dev/null 2>&1; then
305 echo "const EPOLLRDHUP = 0x2000" >> ${OUT}
307 if ! grep '^const EPOLL_CLOEXEC' ${OUT} >/dev/null 2>&1; then
308 echo "const EPOLL_CLOEXEC = 02000000" >> ${OUT}
311 # Prctl constants.
312 grep '^const _PR_' gen-sysinfo.go |
313 sed -e 's/^\(const \)_\(PR_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
315 # Ptrace constants.
316 grep '^const _PTRACE' gen-sysinfo.go |
317 sed -e 's/^\(const \)_\(PTRACE[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
318 # We need some ptrace options that are not defined in older versions
319 # of glibc.
320 if ! grep '^const PTRACE_SETOPTIONS' ${OUT} > /dev/null 2>&1; then
321 echo "const PTRACE_SETOPTIONS = 0x4200" >> ${OUT}
323 if ! grep '^const PTRACE_O_TRACESYSGOOD' ${OUT} > /dev/null 2>&1; then
324 echo "const PTRACE_O_TRACESYSGOOD = 0x1" >> ${OUT}
326 if ! grep '^const PTRACE_O_TRACEFORK' ${OUT} > /dev/null 2>&1; then
327 echo "const PTRACE_O_TRACEFORK = 0x2" >> ${OUT}
329 if ! grep '^const PTRACE_O_TRACEVFORK' ${OUT} > /dev/null 2>&1; then
330 echo "const PTRACE_O_TRACEVFORK = 0x4" >> ${OUT}
332 if ! grep '^const PTRACE_O_TRACECLONE' ${OUT} > /dev/null 2>&1; then
333 echo "const PTRACE_O_TRACECLONE = 0x8" >> ${OUT}
335 if ! grep '^const PTRACE_O_TRACEEXEC' ${OUT} > /dev/null 2>&1; then
336 echo "const PTRACE_O_TRACEEXEC = 0x10" >> ${OUT}
338 if ! grep '^const PTRACE_O_TRACEVFORKDONE' ${OUT} > /dev/null 2>&1; then
339 echo "const PTRACE_O_TRACEVFORKDONE = 0x20" >> ${OUT}
341 if ! grep '^const PTRACE_O_TRACEEXIT' ${OUT} > /dev/null 2>&1; then
342 echo "const PTRACE_O_TRACEEXIT = 0x40" >> ${OUT}
344 if ! grep '^const PTRACE_O_MASK' ${OUT} > /dev/null 2>&1; then
345 echo "const PTRACE_O_MASK = 0x7f" >> ${OUT}
347 if ! grep '^const _PTRACE_GETEVENTMSG' ${OUT} > /dev/null 2>&1; then
348 echo "const PTRACE_GETEVENTMSG = 0x4201" >> ${OUT}
350 if ! grep '^const PTRACE_EVENT_FORK' ${OUT} > /dev/null 2>&1; then
351 echo "const PTRACE_EVENT_FORK = 1" >> ${OUT}
353 if ! grep '^const PTRACE_EVENT_VFORK' ${OUT} > /dev/null 2>&1; then
354 echo "const PTRACE_EVENT_VFORK = 2" >> ${OUT}
356 if ! grep '^const PTRACE_EVENT_CLONE' ${OUT} > /dev/null 2>&1; then
357 echo "const PTRACE_EVENT_CLONE = 3" >> ${OUT}
359 if ! grep '^const PTRACE_EVENT_EXEC' ${OUT} > /dev/null 2>&1; then
360 echo "const PTRACE_EVENT_EXEC = 4" >> ${OUT}
362 if ! grep '^const PTRACE_EVENT_VFORK_DONE' ${OUT} > /dev/null 2>&1; then
363 echo "const PTRACE_EVENT_VFORK_DONE = 5" >> ${OUT}
365 if ! grep '^const PTRACE_EVENT_EXIT' ${OUT} > /dev/null 2>&1; then
366 echo "const PTRACE_EVENT_EXIT = 6" >> ${OUT}
368 if ! grep '^const _PTRACE_TRACEME' ${OUT} > /dev/null 2>&1; then
369 echo "const _PTRACE_TRACEME = 0" >> ${OUT}
372 # The registers returned by PTRACE_GETREGS. This is probably
373 # GNU/Linux specific; it should do no harm if there is no
374 # _user_regs_struct.
375 regs=`grep '^type _user_regs_struct struct' gen-sysinfo.go || true`
376 if test "$regs" != ""; then
377 regs=`echo $regs | sed -e 's/type _user_regs_struct struct //' -e 's/[{}]//g'`
378 regs=`echo $regs | sed -e s'/^ *//'`
379 nregs=
380 while test -n "$regs"; do
381 field=`echo $regs | sed -e 's/^\([^;]*\);.*$/\1/'`
382 regs=`echo $regs | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
383 # Capitalize the first character of the field.
384 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
385 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
386 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
387 field="$f$r"
388 nregs="$nregs $field;"
389 done
390 echo "type PtraceRegs struct {$nregs }" >> ${OUT}
393 # Some basic types.
394 echo 'type Size_t _size_t' >> ${OUT}
395 echo "type Ssize_t _ssize_t" >> ${OUT}
396 if grep '^const _HAVE_OFF64_T = ' gen-sysinfo.go > /dev/null 2>&1; then
397 echo "type Offset_t _off64_t" >> ${OUT}
398 else
399 echo "type Offset_t _off_t" >> ${OUT}
401 echo "type Mode_t _mode_t" >> ${OUT}
402 echo "type Pid_t _pid_t" >> ${OUT}
403 echo "type Uid_t _uid_t" >> ${OUT}
404 echo "type Gid_t _gid_t" >> ${OUT}
405 echo "type Socklen_t _socklen_t" >> ${OUT}
407 # The long type, needed because that is the type that ptrace returns.
408 sizeof_long=`grep '^const ___SIZEOF_LONG__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
409 if test "$sizeof_long" = "4"; then
410 echo "type _C_long int32" >> ${OUT}
411 elif test "$sizeof_long" = "8"; then
412 echo "type _C_long int64" >> ${OUT}
413 else
414 echo 1>&2 "mksysinfo.sh: could not determine size of long (got $sizeof_long)"
415 exit 1
418 # Solaris 2 needs _u?pad128_t, but its default definition in terms of long
419 # double is commented by -fdump-go-spec.
420 if grep "^// type _pad128_t" gen-sysinfo.go > /dev/null 2>&1; then
421 echo "type _pad128_t struct { _l [4]int32; }" >> ${OUT}
423 if grep "^// type _upad128_t" gen-sysinfo.go > /dev/null 2>&1; then
424 echo "type _upad128_t struct { _l [4]uint32; }" >> ${OUT}
427 # The time_t type.
428 if grep '^type _time_t ' gen-sysinfo.go > /dev/null 2>&1; then
429 echo 'type Time_t _time_t' >> ${OUT}
432 # The time structures need special handling: we need to name the
433 # types, so that we can cast integers to the right types when
434 # assigning to the structures.
435 timeval=`grep '^type _timeval ' gen-sysinfo.go`
436 timeval_sec=`echo $timeval | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
437 timeval_usec=`echo $timeval | sed -n -e 's/^.*tv_usec \([^ ]*\);.*$/\1/p'`
438 echo "type Timeval_sec_t $timeval_sec" >> ${OUT}
439 echo "type Timeval_usec_t $timeval_usec" >> ${OUT}
440 echo $timeval | \
441 sed -e 's/type _timeval /type Timeval /' \
442 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timeval_sec_t/' \
443 -e 's/tv_usec *[a-zA-Z0-9_]*/Usec Timeval_usec_t/' >> ${OUT}
444 timespec=`grep '^type _timespec ' gen-sysinfo.go || true`
445 if test "$timespec" = ""; then
446 # IRIX 6.5 has __timespec instead.
447 timespec=`grep '^type ___timespec ' gen-sysinfo.go || true`
449 timespec_sec=`echo $timespec | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
450 timespec_nsec=`echo $timespec | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
451 echo "type Timespec_sec_t $timespec_sec" >> ${OUT}
452 echo "type Timespec_nsec_t $timespec_nsec" >> ${OUT}
453 echo $timespec | \
454 sed -e 's/^type ___timespec /type Timespec /' \
455 -e 's/^type _timespec /type Timespec /' \
456 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timespec_sec_t/' \
457 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timespec_nsec_t/' >> ${OUT}
459 timestruc=`grep '^type _timestruc_t ' gen-sysinfo.go || true`
460 if test "$timestruc" != ""; then
461 timestruc_sec=`echo $timestruc | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
462 timestruc_nsec=`echo $timestruc | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
463 echo "type Timestruc_sec_t $timestruc_sec" >> ${OUT}
464 echo "type Timestruc_nsec_t $timestruc_nsec" >> ${OUT}
465 echo $timestruc | \
466 sed -e 's/^type _timestruc_t /type Timestruc /' \
467 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timestruc_sec_t/' \
468 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timestruc_nsec_t/' >> ${OUT}
471 # The tms struct.
472 grep '^type _tms ' gen-sysinfo.go | \
473 sed -e 's/type _tms/type Tms/' \
474 -e 's/tms_utime/Utime/' \
475 -e 's/tms_stime/Stime/' \
476 -e 's/tms_cutime/Cutime/' \
477 -e 's/tms_cstime/Cstime/' \
478 >> ${OUT}
480 # The stat type.
481 # Prefer largefile variant if available.
482 stat=`grep '^type _stat64 ' gen-sysinfo.go || true`
483 if test "$stat" != ""; then
484 grep '^type _stat64 ' gen-sysinfo.go
485 else
486 grep '^type _stat ' gen-sysinfo.go
487 fi | sed -e 's/type _stat64/type Stat_t/' \
488 -e 's/type _stat/type Stat_t/' \
489 -e 's/st_dev/Dev/' \
490 -e 's/st_ino/Ino/g' \
491 -e 's/st_nlink/Nlink/' \
492 -e 's/st_mode/Mode/' \
493 -e 's/st_uid/Uid/' \
494 -e 's/st_gid/Gid/' \
495 -e 's/st_rdev/Rdev/' \
496 -e 's/st_size/Size/' \
497 -e 's/st_blksize/Blksize/' \
498 -e 's/st_blocks/Blocks/' \
499 -e 's/st_atim/Atim/' \
500 -e 's/st_mtim/Mtim/' \
501 -e 's/st_ctim/Ctim/' \
502 -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
503 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
504 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
505 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
506 -e 's/Godump_[0-9] struct { \([^;]*;\) };/\1/g' \
507 >> ${OUT}
509 # The directory searching types.
510 # Prefer largefile variant if available.
511 dirent=`grep '^type _dirent64 ' gen-sysinfo.go || true`
512 if test "$dirent" != ""; then
513 grep '^type _dirent64 ' gen-sysinfo.go
514 else
515 grep '^type _dirent ' gen-sysinfo.go
516 fi | sed -e 's/type _dirent64/type Dirent/' \
517 -e 's/type _dirent/type Dirent/' \
518 -e 's/d_name \[0+1\]/d_name [0+256]/' \
519 -e 's/d_name/Name/' \
520 -e 's/]int8/]byte/' \
521 -e 's/d_ino/Ino/' \
522 -e 's/d_off/Off/' \
523 -e 's/d_reclen/Reclen/' \
524 -e 's/d_type/Type/' \
525 >> ${OUT}
526 echo "type DIR _DIR" >> ${OUT}
528 # Values for d_type field in dirent.
529 grep '^const _DT_' gen-sysinfo.go |
530 sed -e 's/^\(const \)_\(DT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
532 # The rusage struct.
533 rusage=`grep '^type _rusage struct' gen-sysinfo.go`
534 if test "$rusage" != ""; then
535 # Remove anonymous unions from GNU/Linux <bits/resource.h>.
536 rusage=`echo $rusage | sed -e 's/Godump_[0-9]* struct {\([^}]*\)};/\1/g'`
537 rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
538 rusage=`echo $rusage | sed -e 's/^ *//'`
539 nrusage=
540 while test -n "$rusage"; do
541 field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
542 rusage=`echo $rusage | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
543 # Drop the leading ru_, capitalize the next character.
544 field=`echo $field | sed -e 's/^ru_//'`
545 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
546 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
547 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
548 # Fix _timeval _timespec, and _timestruc_t.
549 r=`echo $r | sed -e s'/ _timeval$/ Timeval/'`
550 r=`echo $r | sed -e s'/ _timespec$/ Timespec/'`
551 r=`echo $r | sed -e s'/ _timestruc_t$/ Timestruc/'`
552 field="$f$r"
553 nrusage="$nrusage $field;"
554 done
555 echo "type Rusage struct {$nrusage }" >> ${OUT}
556 else
557 echo "type Rusage struct {}" >> ${OUT}
560 # The RUSAGE constants.
561 grep '^const _RUSAGE_' gen-sysinfo.go | \
562 sed -e 's/^\(const \)_\(RUSAGE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
564 # The utsname struct.
565 grep '^type _utsname ' gen-sysinfo.go | \
566 sed -e 's/_utsname/Utsname/' \
567 -e 's/sysname/Sysname/' \
568 -e 's/nodename/Nodename/' \
569 -e 's/release/Release/' \
570 -e 's/version/Version/' \
571 -e 's/machine/Machine/' \
572 -e 's/domainname/Domainname/' \
573 >> ${OUT}
575 # The iovec struct.
576 iovec=`grep '^type _iovec ' gen-sysinfo.go`
577 iovec_len=`echo $iovec | sed -n -e 's/^.*iov_len \([^ ]*\);.*$/\1/p'`
578 echo "type Iovec_len_t $iovec_len" >> ${OUT}
579 echo $iovec | \
580 sed -e 's/_iovec/Iovec/' \
581 -e 's/iov_base/Base/' \
582 -e 's/iov_len *[a-zA-Z0-9_]*/Len Iovec_len_t/' \
583 >> ${OUT}
585 # The msghdr struct.
586 msghdr=`grep '^type _msghdr ' gen-sysinfo.go`
587 msghdr_controllen=`echo $msghdr | sed -n -e 's/^.*msg_controllen \([^ ]*\);.*$/\1/p'`
588 echo "type Msghdr_controllen_t $msghdr_controllen" >> ${OUT}
589 echo $msghdr | \
590 sed -e 's/_msghdr/Msghdr/' \
591 -e 's/msg_name/Name/' \
592 -e 's/msg_namelen/Namelen/' \
593 -e 's/msg_iov/Iov/' \
594 -e 's/msg_iovlen/Iovlen/' \
595 -e 's/_iovec/Iovec/' \
596 -e 's/msg_control/Control/' \
597 -e 's/msg_controllen *[a-zA-Z0-9_]*/Controllen Msghdr_controllen_t/' \
598 -e 's/msg_flags/Flags/' \
599 >> ${OUT}
601 # The MSG_ flags for Msghdr.
602 grep '^const _MSG_' gen-sysinfo.go | \
603 sed -e 's/^\(const \)_\(MSG_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
605 # The cmsghdr struct.
606 cmsghdr=`grep '^type _cmsghdr ' gen-sysinfo.go`
607 if test -n "$cmsghdr"; then
608 cmsghdr_len=`echo $cmsghdr | sed -n -e 's/^.*cmsg_len \([^ ]*\);.*$/\1/p'`
609 echo "type Cmsghdr_len_t $cmsghdr_len" >> ${OUT}
610 echo "$cmsghdr" | \
611 sed -e 's/_cmsghdr/Cmsghdr/' \
612 -e 's/cmsg_len *[a-zA-Z0-9_]*/Len Cmsghdr_len_t/' \
613 -e 's/cmsg_level/Level/' \
614 -e 's/cmsg_type/Type/' \
615 -e 's/\[\]/[0]/' \
616 >> ${OUT}
619 # The SCM_ flags for Cmsghdr.
620 grep '^const _SCM_' gen-sysinfo.go | \
621 sed -e 's/^\(const \)_\(SCM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
623 # The ucred struct.
624 grep '^type _ucred ' gen-sysinfo.go | \
625 sed -e 's/_ucred/Ucred/' \
626 -e 's/pid/Pid/' \
627 -e 's/uid/Uid/' \
628 -e 's/gid/Gid/' \
629 >> ${OUT}
631 # The ip_mreq struct.
632 grep '^type _ip_mreq ' gen-sysinfo.go | \
633 sed -e 's/_ip_mreq/IPMreq/' \
634 -e 's/imr_multiaddr/Multiaddr/' \
635 -e 's/imr_interface/Interface/' \
636 -e 's/_in_addr/[4]byte/g' \
637 >> ${OUT}
639 # We need IPMreq to compile the net package.
640 if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
641 echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
644 # The ipv6_mreq struct.
645 grep '^type _ipv6_mreq ' gen-sysinfo.go | \
646 sed -e 's/_ipv6_mreq/IPv6Mreq/' \
647 -e 's/ipv6mr_multiaddr/Multiaddr/' \
648 -e 's/ipv6mr_interface/Interface/' \
649 -e 's/_in6_addr/[16]byte/' \
650 >> ${OUT}
652 # We need IPv6Mreq to compile the net package.
653 if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
654 echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
657 # The ip_mreqn struct.
658 grep '^type _ip_mreqn ' gen-sysinfo.go | \
659 sed -e 's/_ip_mreqn/IPMreqn/' \
660 -e 's/imr_multiaddr/Multiaddr/' \
661 -e 's/imr_address/Address/' \
662 -e 's/imr_ifindex/Ifindex/' \
663 -e 's/_in_addr/[4]byte/g' \
664 >> ${OUT}
666 # We need IPMreq to compile the net package.
667 if ! grep 'type IPMreqn ' ${OUT} >/dev/null 2>&1; then
668 echo 'type IPMreqn struct { Multiaddr [4]byte; Interface [4]byte; Ifindex int32 }' >> ${OUT}
671 # Try to guess the type to use for fd_set.
672 fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
673 fds_bits_type="_C_long"
674 if test "$fd_set" != ""; then
675 fds_bits_type=`echo $fd_set | sed -e 's/.*[]]\([^;]*\); }$/\1/'`
677 echo "type fds_bits_type $fds_bits_type" >> ${OUT}
679 # The addrinfo struct.
680 grep '^type _addrinfo ' gen-sysinfo.go | \
681 sed -e 's/_addrinfo/Addrinfo/g' \
682 -e 's/ ai_/ Ai_/g' \
683 >> ${OUT}
685 # The addrinfo flags and errors.
686 grep '^const _AI_' gen-sysinfo.go | \
687 sed -e 's/^\(const \)_\(AI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
688 grep '^const _EAI_' gen-sysinfo.go | \
689 sed -e 's/^\(const \)_\(EAI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
691 # The passwd struct.
692 grep '^type _passwd ' gen-sysinfo.go | \
693 sed -e 's/_passwd/Passwd/' \
694 -e 's/ pw_/ Pw_/g' \
695 >> ${OUT}
697 # The ioctl flags for the controlling TTY.
698 grep '^const _TIOC' gen-sysinfo.go | \
699 grep -v '_val =' | \
700 sed -e 's/^\(const \)_\(TIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
701 # We need TIOCGWINSZ.
702 if ! grep '^const TIOCGWINSZ' ${OUT} >/dev/null 2>&1; then
703 if grep '^const _TIOCGWINSZ_val' ${OUT} >/dev/null 2>&1; then
704 echo 'const TIOCGWINSZ = _TIOCGWINSZ_val' >> ${OUT}
708 # The ioctl flags for terminal control
709 grep '^const _TC[GS]ET' gen-sysinfo.go | \
710 sed -e 's/^\(const \)_\(TC[GS]ET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
712 # ioctl constants. Might fall back to 0 if TIOCNXCL is missing, too, but
713 # needs handling in syscalls.exec.go.
714 if ! grep '^const _TIOCSCTTY ' gen-sysinfo.go >/dev/null 2>&1; then
715 if grep '^const _TIOCNXCL ' gen-sysinfo.go >/dev/null 2>&1; then
716 echo "const TIOCSCTTY = TIOCNXCL" >> ${OUT}
720 # The nlmsghdr struct.
721 grep '^type _nlmsghdr ' gen-sysinfo.go | \
722 sed -e 's/_nlmsghdr/NlMsghdr/' \
723 -e 's/nlmsg_len/Len/' \
724 -e 's/nlmsg_type/Type/' \
725 -e 's/nlmsg_flags/Flags/' \
726 -e 's/nlmsg_seq/Seq/' \
727 -e 's/nlmsg_pid/Pid/' \
728 >> ${OUT}
730 # The nlmsg flags and operators.
731 grep '^const _NLM' gen-sysinfo.go | \
732 sed -e 's/^\(const \)_\(NLM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
734 # NLMSG_HDRLEN is defined as an expression using sizeof.
735 if ! grep '^const NLMSG_HDRLEN' ${OUT} > /dev/null 2>&1; then
736 if grep '^const _sizeof_nlmsghdr ' ${OUT} > /dev/null 2>&1; then
737 echo 'const NLMSG_HDRLEN = (_sizeof_nlmsghdr + (NLMSG_ALIGNTO-1)) &^ (NLMSG_ALIGNTO-1)' >> ${OUT}
741 # The rtmsg struct.
742 grep '^type _rtmsg ' gen-sysinfo.go | \
743 sed -e 's/_rtmsg/RtMsg/' \
744 -e 's/rtm_family/Family/' \
745 -e 's/rtm_dst_len/Dst_len/' \
746 -e 's/rtm_src_len/Src_len/' \
747 -e 's/rtm_tos/Tos/' \
748 -e 's/rtm_table/Table/' \
749 -e 's/rtm_protocol/Protocol/' \
750 -e 's/rtm_scope/Scope/' \
751 -e 's/rtm_type/Type/' \
752 -e 's/rtm_flags/Flags/' \
753 >> ${OUT}
755 # The rtgenmsg struct.
756 grep '^type _rtgenmsg ' gen-sysinfo.go | \
757 sed -e 's/_rtgenmsg/RtGenmsg/' \
758 -e 's/rtgen_family/Family/' \
759 >> ${OUT}
761 # The routing message flags.
762 grep '^const _RT_' gen-sysinfo.go | \
763 sed -e 's/^\(const \)_\(RT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
764 grep '^const _RTA' gen-sysinfo.go | \
765 sed -e 's/^\(const \)_\(RTA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
766 grep '^const _RTF' gen-sysinfo.go | \
767 sed -e 's/^\(const \)_\(RTF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
768 grep '^const _RTCF' gen-sysinfo.go | \
769 sed -e 's/^\(const \)_\(RTCF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
770 grep '^const _RTM' gen-sysinfo.go | \
771 sed -e 's/^\(const \)_\(RTM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
772 grep '^const _RTN' gen-sysinfo.go | \
773 sed -e 's/^\(const \)_\(RTN[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
774 grep '^const _RTPROT' gen-sysinfo.go | \
775 sed -e 's/^\(const \)_\(RTPROT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
777 # The ifinfomsg struct.
778 grep '^type _ifinfomsg ' gen-sysinfo.go | \
779 sed -e 's/_ifinfomsg/IfInfomsg/' \
780 -e 's/ifi_family/Family/' \
781 -e 's/ifi_type/Type/' \
782 -e 's/ifi_index/Index/' \
783 -e 's/ifi_flags/Flags/' \
784 -e 's/ifi_change/Change/' \
785 >> ${OUT}
787 # The interface information types and flags.
788 grep '^const _IFA' gen-sysinfo.go | \
789 sed -e 's/^\(const \)_\(IFA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
790 grep '^const _IFLA' gen-sysinfo.go | \
791 sed -e 's/^\(const \)_\(IFLA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
792 grep '^const _IFF' gen-sysinfo.go | \
793 sed -e 's/^\(const \)_\(IFF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
794 grep '^const _IFNAMSIZ' gen-sysinfo.go | \
795 sed -e 's/^\(const \)_\(IFNAMSIZ[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
796 grep '^const _SIOC' gen-sysinfo.go |
797 sed -e 's/^\(const \)_\(SIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
799 # The ifaddrmsg struct.
800 grep '^type _ifaddrmsg ' gen-sysinfo.go | \
801 sed -e 's/_ifaddrmsg/IfAddrmsg/' \
802 -e 's/ifa_family/Family/' \
803 -e 's/ifa_prefixlen/Prefixlen/' \
804 -e 's/ifa_flags/Flags/' \
805 -e 's/ifa_scope/Scope/' \
806 -e 's/ifa_index/Index/' \
807 >> ${OUT}
809 # The rtattr struct.
810 grep '^type _rtattr ' gen-sysinfo.go | \
811 sed -e 's/_rtattr/RtAttr/' \
812 -e 's/rta_len/Len/' \
813 -e 's/rta_type/Type/' \
814 >> ${OUT}
816 # The in_pktinfo struct.
817 grep '^type _in_pktinfo ' gen-sysinfo.go | \
818 sed -e 's/_in_pktinfo/Inet4Pktinfo/' \
819 -e 's/ipi_ifindex/Ifindex/' \
820 -e 's/ipi_spec_dst/Spec_dst/' \
821 -e 's/ipi_addr/Addr/' \
822 -e 's/_in_addr/[4]byte/g' \
823 >> ${OUT}
825 # The in6_pktinfo struct.
826 grep '^type _in6_pktinfo ' gen-sysinfo.go | \
827 sed -e 's/_in6_pktinfo/Inet6Pktinfo/' \
828 -e 's/ipi6_addr/Addr/' \
829 -e 's/ipi6_ifindex/Ifindex/' \
830 -e 's/_in6_addr/[16]byte/' \
831 >> ${OUT}
833 # The termios struct.
834 grep '^type _termios ' gen-sysinfo.go | \
835 sed -e 's/_termios/Termios/' \
836 -e 's/c_iflag/Iflag/' \
837 -e 's/c_oflag/Oflag/' \
838 -e 's/c_cflag/Cflag/' \
839 -e 's/c_lflag/Lflag/' \
840 -e 's/c_line/Line/' \
841 -e 's/c_cc/Cc/' \
842 -e 's/c_ispeed/Ispeed/' \
843 -e 's/c_ospeed/Ospeed/' \
844 >> ${OUT}
846 # The termios constants.
847 for n in IGNBRK BRKINT IGNPAR PARMRK INPCK ISTRIP INLCR IGNCR ICRNL IUCLC \
848 IXON IXANY IXOFF IMAXBEL IUTF8 OPOST OLCUC ONLCR OCRNL ONOCR ONLRET \
849 OFILL OFDEL NLDLY NL0 NL1 CRDLY CR0 CR1 CR2 CR3 CS5 CS6 CS7 CS8 TABDLY \
850 BSDLY VTDLY FFDLY CBAUD CBAUDEX CSIZE CSTOPB CREAD PARENB PARODD HUPCL \
851 CLOCAL LOBLK CIBAUD CMSPAR CRTSCTS ISIG ICANON XCASE ECHO ECHOE ECHOK \
852 ECHONL ECHOCTL ECHOPRT ECHOKE DEFECHO FLUSHO NOFLSH TOSTOP PENDIN IEXTEN \
853 VINTR VQUIT VERASE VKILL VEOF VMIN VEOL VTIME VEOL2 VSWTCH VSTART VSTOP \
854 VSUSP VDSUSP VLNEXT VWERASE VREPRINT VDISCARD VSTATUS TCSANOW TCSADRAIN \
855 TCSAFLUSH TCIFLUSH TCOFLUSH TCIOFLUSH TCOOFF TCOON TCIOFF TCION B0 B50 \
856 B75 B110 B134 B150 B200 B300 B600 B1200 B1800 B2400 B4800 B9600 B19200 \
857 B38400 B57600 B115200 B230400 B460800 B500000 B576000 B921600 B1000000 \
858 B1152000 B1500000 B2000000 B2500000 B3000000 B3500000 B4000000; do
860 grep "^const _$n " gen-sysinfo.go | \
861 sed -e 's/^\(const \)_\([^=]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
862 done
864 # The mount flags
865 grep '^const _MNT_' gen-sysinfo.go |
866 sed -e 's/^\(const \)_\(MNT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
867 grep '^const _MS_' gen-sysinfo.go |
868 sed -e 's/^\(const \)_\(MS_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
870 # The fallocate flags.
871 grep '^const _FALLOC_' gen-sysinfo.go |
872 sed -e 's/^\(const \)_\(FALLOC_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
874 # The statfs struct.
875 # Prefer largefile variant if available.
876 statfs=`grep '^type _statfs64 ' gen-sysinfo.go || true`
877 if test "$statfs" != ""; then
878 grep '^type _statfs64 ' gen-sysinfo.go
879 else
880 grep '^type _statfs ' gen-sysinfo.go
881 fi | sed -e 's/type _statfs64/type Statfs_t/' \
882 -e 's/type _statfs/type Statfs_t/' \
883 -e 's/f_type/Type/' \
884 -e 's/f_bsize/Bsize/' \
885 -e 's/f_blocks/Blocks/' \
886 -e 's/f_bfree/Bfree/' \
887 -e 's/f_bavail/Bavail/' \
888 -e 's/f_files/Files/' \
889 -e 's/f_ffree/Ffree/' \
890 -e 's/f_fsid/Fsid/' \
891 -e 's/f_namelen/Namelen/' \
892 -e 's/f_frsize/Frsize/' \
893 -e 's/f_flags/Flags/' \
894 -e 's/f_spare/Spare/' \
895 >> ${OUT}
897 # The timex struct.
898 timex=`grep '^type _timex ' gen-sysinfo.go || true`
899 if test "$timex" = ""; then
900 timex=`grep '^// type _timex ' gen-sysinfo.go || true`
901 if test "$timex" != ""; then
902 timex=`echo $timex | sed -e 's|// ||' -e 's/INVALID-bit-field/int32/g'`
905 if test "$timex" != ""; then
906 echo "$timex" | \
907 sed -e 's/_timex/Timex/' \
908 -e 's/modes/Modes/' \
909 -e 's/offset/Offset/' \
910 -e 's/freq/Freq/' \
911 -e 's/maxerror/Maxerror/' \
912 -e 's/esterror/Esterror/' \
913 -e 's/status/Status/' \
914 -e 's/constant/Constant/' \
915 -e 's/precision/Precision/' \
916 -e 's/tolerance/Tolerance/' \
917 -e 's/ time / Time /' \
918 -e 's/tick/Tick/' \
919 -e 's/ppsfreq/Ppsfreq/' \
920 -e 's/jitter/Jitter/' \
921 -e 's/shift/Shift/' \
922 -e 's/stabil/Stabil/' \
923 -e 's/jitcnt/Jitcnt/' \
924 -e 's/calcnt/Calcnt/' \
925 -e 's/errcnt/Errcnt/' \
926 -e 's/stbcnt/Stbcnt/' \
927 -e 's/tai/Tai/' \
928 -e 's/_timeval/Timeval/' \
929 >> ${OUT}
932 # The rlimit struct.
933 grep '^type _rlimit ' gen-sysinfo.go | \
934 sed -e 's/_rlimit/Rlimit/' \
935 -e 's/rlim_cur/Cur/' \
936 -e 's/rlim_max/Max/' \
937 >> ${OUT}
939 # The RLIMIT constants.
940 grep '^const _RLIMIT_' gen-sysinfo.go |
941 sed -e 's/^\(const \)_\(RLIMIT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
942 grep '^const _RLIM_' gen-sysinfo.go |
943 sed -e 's/^\(const \)_\(RLIM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
945 # The sysinfo struct.
946 grep '^type _sysinfo ' gen-sysinfo.go | \
947 sed -e 's/_sysinfo/Sysinfo_t/' \
948 -e 's/uptime/Uptime/' \
949 -e 's/loads/Loads/' \
950 -e 's/totalram/Totalram/' \
951 -e 's/freeram/Freeram/' \
952 -e 's/sharedram/Sharedram/' \
953 -e 's/bufferram/Bufferram/' \
954 -e 's/totalswap/Totalswap/' \
955 -e 's/freeswap/Freeswap/' \
956 -e 's/procs/Procs/' \
957 -e 's/totalhigh/Totalhigh/' \
958 -e 's/freehigh/Freehigh/' \
959 -e 's/mem_unit/Unit/' \
960 >> ${OUT}
962 # The ustat struct.
963 grep '^type _ustat ' gen-sysinfo.go | \
964 sed -e 's/_ustat/Ustat_t/' \
965 -e 's/f_tfree/Tfree/' \
966 -e 's/f_tinode/Tinoe/' \
967 -e 's/f_fname/Fname/' \
968 -e 's/f_fpack/Fpack/' \
969 >> ${OUT}
970 # Force it to be defined, as on some older GNU/Linux systems the
971 # header file fails when using with <linux/filter.h>.
972 if ! grep 'type _ustat ' gen-sysinfo.go >/dev/null 2>&1; then
973 echo 'type Ustat_t struct { Tfree int32; Tinoe uint64; Fname [5+1]int8; Fpack [5+1]int8; }' >> ${OUT}
976 # The utimbuf struct.
977 grep '^type _utimbuf ' gen-sysinfo.go | \
978 sed -e 's/_utimbuf/Utimbuf/' \
979 -e 's/actime/Actime/' \
980 -e 's/modtime/Modtime/' \
981 >> ${OUT}
983 # The LOCK flags for flock.
984 grep '^const _LOCK_' gen-sysinfo.go |
985 sed -e 's/^\(const \)_\(LOCK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
987 # The GNU/Linux LINUX_REBOOT flags.
988 grep '^const _LINUX_REBOOT_' gen-sysinfo.go |
989 sed -e 's/^\(const \)_\(LINUX_REBOOT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
991 # The GNU/Linux sock_filter struct.
992 grep '^type _sock_filter ' gen-sysinfo.go | \
993 sed -e 's/_sock_filter/SockFilter/' \
994 -e 's/code/Code/' \
995 -e 's/jt/Jt/' \
996 -e 's/jf/Jf/' \
997 -e 's/k /K /' \
998 >> ${OUT}
1000 # The GNU/Linux sock_fprog struct.
1001 grep '^type _sock_fprog ' gen-sysinfo.go | \
1002 sed -e 's/_sock_fprog/SockFprog/' \
1003 -e 's/len/Len/' \
1004 -e 's/filter/Filter/' \
1005 -e 's/_sock_filter/SockFilter/' \
1006 >> ${OUT}
1008 # The GNU/Linux filter flags.
1009 grep '^const _BPF_' gen-sysinfo.go | \
1010 sed -e 's/^\(const \)_\(BPF_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1012 # The GNU/Linux nlattr struct.
1013 grep '^type _nlattr ' gen-sysinfo.go | \
1014 sed -e 's/_nlattr/NlAttr/' \
1015 -e 's/nla_len/Len/' \
1016 -e 's/nla_type/Type/' \
1017 >> ${OUT}
1019 # The GNU/Linux nlmsgerr struct.
1020 grep '^type _nlmsgerr ' gen-sysinfo.go | \
1021 sed -e 's/_nlmsgerr/NlMsgerr/' \
1022 -e 's/error/Error/' \
1023 -e 's/msg/Msg/' \
1024 -e 's/_nlmsghdr/NlMsghdr/' \
1025 >> ${OUT}
1027 # The GNU/Linux rtnexthop struct.
1028 grep '^type _rtnexthop ' gen-sysinfo.go | \
1029 sed -e 's/_rtnexthop/RtNexthop/' \
1030 -e 's/rtnh_len/Len/' \
1031 -e 's/rtnh_flags/Flags/' \
1032 -e 's/rtnh_hops/Hops/' \
1033 -e 's/rtnh_ifindex/Ifindex/' \
1034 >> ${OUT}
1036 # The GNU/Linux netlink flags.
1037 grep '^const _NETLINK_' gen-sysinfo.go | \
1038 sed -e 's/^\(const \)_\(NETLINK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1039 grep '^const _NLA_' gen-sysinfo.go | \
1040 sed -e 's/^\(const \)_\(NLA_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1042 # The GNU/Linux packet socket flags.
1043 grep '^const _PACKET_' gen-sysinfo.go | \
1044 sed -e 's/^\(const \)_\(PACKET_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1046 # The GNU/Linux inotify_event struct.
1047 grep '^type _inotify_event ' gen-sysinfo.go | \
1048 sed -e 's/_inotify_event/InotifyEvent/' \
1049 -e 's/wd/Wd/' \
1050 -e 's/mask/Mask/' \
1051 -e 's/cookie/Cookie/' \
1052 -e 's/len/Len/' \
1053 -e 's/name/Name/' \
1054 -e 's/\[\]/[0]/' \
1055 -e 's/\[0\]byte/[0]int8/' \
1056 >> ${OUT}
1058 # The Solaris 11 Update 1 _zone_net_addr_t struct.
1059 grep '^type _zone_net_addr_t ' gen-sysinfo.go | \
1060 sed -e 's/_in6_addr/[16]byte/' \
1061 >> ${OUT}
1063 # Struct sizes.
1064 set cmsghdr Cmsghdr ip_mreq IPMreq ip_mreqn IPMreqn ipv6_mreq IPv6Mreq \
1065 ifaddrmsg IfAddrmsg ifinfomsg IfInfomsg in_pktinfo Inet4Pktinfo \
1066 in6_pktinfo Inet6Pktinfo inotify_event InotifyEvent linger Linger \
1067 msghdr Msghdr nlattr NlAttr nlmsgerr NlMsgerr nlmsghdr NlMsghdr \
1068 rtattr RtAttr rtgenmsg RtGenmsg rtmsg RtMsg rtnexthop RtNexthop \
1069 sock_filter SockFilter sock_fprog SockFprog ucred Ucred
1070 while test $# != 0; do
1071 nc=$1
1072 ngo=$2
1073 shift
1074 shift
1075 if grep "^const _sizeof_$nc =" gen-sysinfo.go >/dev/null 2>&1; then
1076 echo "const Sizeof$ngo = _sizeof_$nc" >> ${OUT}
1078 done
1080 # In order to compile the net package, we need some sizes to exist
1081 # even if the types do not.
1082 if ! grep 'const SizeofIPMreq ' ${OUT} >/dev/null 2>&1; then
1083 echo 'const SizeofIPMreq = 8' >> ${OUT}
1085 if ! grep 'const SizeofIPv6Mreq ' ${OUT} >/dev/null 2>&1; then
1086 echo 'const SizeofIPv6Mreq = 20' >> ${OUT}
1088 if ! grep 'const SizeofIPMreqn ' ${OUT} >/dev/null 2>&1; then
1089 echo 'const SizeofIPMreqn = 12' >> ${OUT}
1092 exit $?